/*=========================================================================

  Library:   CTK

  Copyright (c) Kitware Inc.

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

      http://www.commontk.org/LICENSE

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.

=========================================================================*/

// Qt includes
#include <QApplication>
#include <QTimer>
// CTK includes
#include "ctkColorDialog.h"
#include "ctkColorPickerButton.h"

// STD includes
#include <cstdlib>
#include <iostream>

//-----------------------------------------------------------------------------
int ctkColorDialogTest2(int argc, char * argv [] )
{
  QApplication app(argc, argv);

  ctkColorPickerButton* extraPanel = new ctkColorPickerButton;
  ctkColorDialog::addDefaultTab(extraPanel, "Extra", SIGNAL(colorChanged(QColor)));

  if (argc < 2 || QString(argv[1]) != "-I" )
    {
    // quit for the first event loop of the opened dialog
    QTimer::singleShot(200, &app, SLOT(quit()));
    // quit the application
    QTimer::singleShot(300, &app, SLOT(quit()));
    }

  QColor color = ctkColorDialog::getColor(Qt::black,0 , "", 0);
  
  return app.exec();
}
