/*=============================================================================

  Library: CTK

  Copyright (c) German Cancer Research Center,
    Division of Medical and Biological Informatics

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.

=============================================================================*/

#ifndef CTKHOSTEDAPPPLACEHOLDERWIDGET_H
#define CTKHOSTEDAPPPLACEHOLDERWIDGET_H

#include <QFrame>
#include <QDebug>
#include <org_commontk_dah_examplehost_Export.h>

class org_commontk_dah_examplehost_EXPORT ctkHostedAppPlaceholderWidget : public QFrame
{
  Q_OBJECT

public:

  explicit ctkHostedAppPlaceholderWidget(QWidget *parent = 0);
  QRect getAbsolutePosition()
  {
    QWidget* current = this;
    int x = 0;
    int y = 0;
    do
    {
      x = x + current->x();
      y = y + current->y();
      current = dynamic_cast<QWidget*>(current->parent());
    } while (current);
    return QRect(x,y,width(),height());
  }

signals:

  void resized();

protected:

  void resizeEvent(QResizeEvent* /* event */) { emit resized(); }
};

#endif // CTKHOSTEDAPPPLACEHOLDERWIDGET_H
